<template>
  <div>
    <b-button
      variant="success"
      class="float-right"
      @click="addNewUser"
      v-b-modal.modal-form-user
      >Add New</b-button
    >
    <b-modal
      id="modal-form-user"
      ref="modal-form-user"
      :title="title"
      @hidden="resetModal"
      @ok="handleOk"
    >
      <form ref="form" @submit.stop.prevent="handleSubmit">
        <b-form-group
          label="Student ID"
          label-for="Student ID"
          :invalid-feedback="invalidFeedbackIdstud"
          :valid-feedback="validFeedbackIdstud"
          :state="stateIdstud"
        >
          <b-form-input id="idStudent" v-model="form.idStudent" required></b-form-input>
        </b-form-group>

        <b-form-group
          label="FirstName"
          label-for="FirstName"
          :invalid-feedback="invalidFeedbackfirstName"
          :valid-feedback="validFeedbackfirstName"
          :state="statefirstName"
        >
          <b-form-input id="firstName" v-model="form.firstName" required></b-form-input>
        </b-form-group>

        <b-form-group
          label="LastName"
          label-for="LastName"
          :invalid-feedback="invalidFeedbacklastName"
          :valid-feedback="validFeedbacklastName"
          :state="statelastName"
        >
          <b-form-input id="lastName" v-model="form.lastName" required></b-form-input>
        </b-form-group>

        <b-form-group
          label="Birthday"
          label-for="Birthday"
          :invalid-feedback="invalidFeedbackBirthday"
          :valid-feedback="validFeedbackBirthday"
          :state="stateBirthday"
        >
          <b-form-input id="birthday" v-model="form.birthday" required></b-form-input>
        </b-form-group>

        <b-form-group
          label="Salary"
          label-for="Salary"
          :invalid-feedback="invalidFeedbackSalary"
          :valid-feedback="validFeedbackSalary"
          :state="stateSalary"
        >
          <b-form-input id="salary" v-model="form.salary" required></b-form-input>
        </b-form-group>

        <b-form-group
          label="Gender:"
          label-for="gender"
          :invalid-feedback="invalidFeedbackGender"
          :valid-feedback="validFeedbackGender"
          :state="stateGender"
        >
          <b-form-select
            id="gender"
            v-model="form.gender"
            :options="genderOptions"
            required
          ></b-form-select>
        </b-form-group>

        <b-form-group
          label="Education:"
          label-for="education"
          :invalid-feedback="invalidFeedbackEducation"
          :valid-feedback="validFeedbackEducation"
          :state="stateEducation"
        >
          <b-form-select
            id="education"
            v-model="form.education"
            :options="educationOptions"
            required
          ></b-form-select>
        </b-form-group>

        <b-form-group
          label="Department:"
          label-for="department"
          :invalid-feedback="invalidFeedbackDepartment"
          :valid-feedback="validFeedbackDepartment"
          :state="stateDepartment"
        >
          <b-form-select
            id="department"
            v-model="form.department"
            :options="departmentOptions"
            required
          ></b-form-select>
        </b-form-group>
      </form>
      <b-card class="mt-3" header="Form Data Result">
        <pre class="m-0">{{ form }}</pre>
      </b-card>
    </b-modal>
    <b-table striped hover :items="userList" :fields="fields">
      <template v-slot:cell(operation)="data">
        <b-button @click="editUser(data.item)">Edit</b-button>
        &nbsp;
        <b-button variant="danger" @click="delUser(data.item)">Delete</b-button>
      </template>
    </b-table>
  </div>
</template>

<script>
export default {
  data () {
    return {
      title: 'เพิ่มผู้ใช้ใหม่',
      form: {
        id: -1,
        idStudent: '',
        firstName: '',
        lastName: '',
        birthday: '',
        salary: '',
        gender: null,
        education: null,
        department: null
      },
      genderOptions: [
        { text: 'Select One', value: null },
        { value: 'M', text: 'ผู้ชาย' },
        { value: 'F', text: 'ผู้หญิง' }
      ],
      educationOptions: [
        { text: 'Select One', value: null },
        { value: 'Primary education', text: 'ประถมศึกษา' },
        { value: 'Secondary education', text: 'มัธยมศึกษา' },
        { value: 'Bachelor degree', text: 'ปริญญาตรี' },
        { value: 'Masters degree', text: 'ปริญญาโท' },
        { value: 'PhD', text: 'ปริญญาเอก' }
      ],
      departmentOptions: [
        { text: 'Select One', value: null },
        { value: 'Sales', text: 'การขาย' },
        { value: 'Production', text: 'การผลิต' },
        { value: 'Accounting', text: 'บัญชี' },
        { value: 'Developers', text: 'นักพัฒนา' }
      ],
      userList: [
        {
          id: 1,
          idStudent: '60160012',
          firstName: 'Panu',
          lastName: 'rungkaew',
          birthday: '08-01-2542',
          salary: '25000',
          gender: 'M',
          education: 'ปวส.',
          department: 'การขาย'
        },
        {
          id: 2,
          idStudent: '60160017',
          firstName: 'Deaw',
          lastName: 'Rungkaew',
          birthday: '08-01-2542',
          salary: '25000',
          gender: 'M',
          education: 'ปวส.',
          department: 'การขาย'
        }
      ],
      lastId: 3,
      fields: ['id', 'idStudent', 'firstName', 'lastName', 'birthday', 'salary', 'education', 'department', 'gender', 'operation']
    }
  },
  methods: {
    addNewUser () {
      console.log('Add new user ')
      this.$bvModal.show('modal-form-user')
    },
    editUser (user) {
      console.log('Edit ')
      console.log(user)
      this.title = 'แก้ไขผู้ใช้'
      this.form = { ...user }
      this.$bvModal.show('modal-form-user')
    },
    delUser (user) {
      console.log('Del ')
      console.log(user)
      this.$bvModal
        .msgBoxConfirm('ท่านต้องการลบ ' + user.idStudent + ' หรือไม่!!!', {
          title: 'กรุณายืนยัน',
          size: 'sm',
          buttonSize: 'sm',
          okVariant: 'danger',
          okTitle: 'YES',
          cancelTitle: 'NO',
          footerClass: 'p-2 ',
          hideHeaderClose: false,
          centered: true
        })
        .then(value => {
          if (value) {
            this.deleteUser(user)
          }
        })
    },
    resetModal () {
      this.form = {
        id: -1,
        idStudent: '',
        firstName: '',
        lastName: '',
        birthday: '',
        salary: '',
        gender: null,
        education: null,
        department: null
      }
    },
    handleOk (bvModalEvt) {
      bvModalEvt.preventDefault()
      this.handleSubmit()
    },
    handleSubmit () {
      // Check Validate
      if (this.stateIdstud === false || this.statefirstName === false || this.statelastName === false ||
        this.stateBirthday === false || this.stateGender === false || this.stateSalary === false ||
        this.stateEducation === false || this.stateDepartment === false) {
        return
      }
      if (this.form.id > 0) {
        // Do when pass validation
        this.updateUser(this.form)
      } else {
        this.addUser(this.form)
      }
      // Hide the modal manually
      this.$nextTick(() => {
        this.$bvModal.hide('modal-form-user')
      })
    },
    addUser (user) {
      user.id = this.lastId++
      this.userList.push(user)
    },
    updateUser (user) {
      const index = this.userList.findIndex(item => item.id === user.id)
      this.userList.splice(index, 1, user)
    },
    deleteUser (user) {
      const index = this.userList.findIndex(item => item.id === user.id)
      this.userList.splice(index, 1)
    }
  },

  computed: {
    stateIdstud () {
      return this.form.idStudent.length === 8
    },
    invalidFeedbackIdstud () {
      if (this.form.idStudent.length === 8) {
        return ''
      } else if (this.form.idStudent.length > 0) {
        return 'รหัสต้องมีขนาด 8 ตัว'
      } else {
        return 'ต้องใส่รหัสประจำตัว'
      }
    },
    validFeedbackIdstud () {
      return this.stateIdstud === true ? 'สำเร็จ' : ''
    },

    statefirstName () {
      return this.form.firstName.length >= 2
    },
    invalidFeedbackfirstName () {
      if (this.form.firstName.length > 2) {
        return ''
      } else if (this.form.firstName.length > 0) {
        return 'ชื่อต้องมีขนาด 2 ตัวอักษร'
      } else {
        return 'ต้องใส่ชื่อ'
      }
    },
    validFeedbackfirstName () {
      return this.statefirstName === true ? 'สำเร็จ' : ''
    },

    statelastName () {
      return this.form.lastName.length >= 2
    },
    invalidFeedbacklastName () {
      if (this.form.lastName.length > 2) {
        return ''
      } else if (this.form.lastName.length > 0) {
        return 'นามสกุลต้องมีขนาด 2 ตัวอักษร'
      } else {
        return 'ต้องใส่นามสกุล'
      }
    },
    validFeedbacklastName () {
      return this.statelastName === true ? 'สำเร็จ' : ''
    },

    stateBirthday () {
      return this.form.birthday.length >= 5
    },
    invalidFeedbackBirthday () {
      if (this.form.birthday.length > 5) {
        return ''
      } else if (this.form.birthday.length > 0) {
        return 'วันเกิดต้องมีขนาด 5 ตัวอักษร'
      } else {
        return 'ต้องใส่วันเกิด'
      }
    },
    validFeedbackBirthday () {
      return this.stateBirthday === true ? 'สำเร็จ' : ''
    },

    stateSalary () {
      return this.form.salary.length >= 5
    },
    invalidFeedbackSalary () {
      if (this.form.salary.length > 4) {
        return ''
      } else if (this.form.salary.length > 0) {
        return 'ต้องระบุให้มากกว่าหลักพัน'
      } else {
        return 'กรุณาระบุเงินเดือน'
      }
    },
    validFeedbackSalary () {
      return this.stateSalary === true ? 'สำเร็จ' : ''
    },

    stateGender () {
      return this.form.gender != null
    },
    invalidFeedbackGender () {
      if (this.form.gender != null) {
        return ''
      } else {
        return 'กรุณาเลือกเพศ'
      }
    },
    validFeedbackGender () {
      return this.stateGender === true ? 'สำเร็จ' : ''
    },

    stateEducation () {
      return this.form.education != null
    },
    invalidFeedbackEducation () {
      if (this.form.education != null) {
        return ''
      } else {
        return 'กรุณาเลือกระดับการศึกษา'
      }
    },
    validFeedbackEducation () {
      return this.stateEducation === true ? 'สำเร็จ' : ''
    },

    stateDepartment () {
      return this.form.department != null
    },
    invalidFeedbackDepartment () {
      if (this.form.department != null) {
        return ''
      } else {
        return 'กรุณาเลือกตำแหน่งงาน'
      }
    },
    validFeedbackDepartment () {
      return this.stateDepartment === true ? 'สำเร็จ' : ''
    }
  }
}
</script>
